package lifegame;

public class Cell {
  /*****************************************************************
   *                          Variables                            *
   *****************************************************************/
  private boolean containsCell;
  private Cell[]  nearbyCells;
  
  /*****************************************************************
   *                         Constructors                          *
   *****************************************************************/
  public Cell(boolean containsCell) {
    this.containsCell = containsCell;
  }
  
  /*****************************************************************
   *                         Public methods                        *
   *****************************************************************/
  public void createNeighborhood(Cell[] nearMe) {
    nearbyCells = nearMe;
  }
  
  public boolean isLiving() {
    return containsCell;
  }
  
  public boolean wantsToDie() {
    int livingCellsAround = getLivingAroundCount();
    return (livingCellsAround <= 1 || livingCellsAround >= 4);
  }
  
  public boolean wantsToLive() {
    int livingCellsAround = getLivingAroundCount();
    return (livingCellsAround == 3);
  }
  
  /*****************************************************************
   *                        Private methods                        *
   *****************************************************************/
  private int getLivingAroundCount() {
    int count = 0;
    for (int i = 0; i < nearbyCells.length; i++) {
      if (nearbyCells[i].containsCell == true)
        count++;
    }
    
    return count;
  }
}
